Index: /trunk/src/VBox/Frontends/VBoxAutostart/VBoxAutostart-win.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxAutostart/VBoxAutostart-win.cpp	(revision 60758)
+++ /trunk/src/VBox/Frontends/VBoxAutostart/VBoxAutostart-win.cpp	(revision 60759)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2013 Oracle Corporation
+ * Copyright (C) 2012-2016 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -21,4 +21,5 @@
 *********************************************************************************************************************************/
 #include <Windows.h>
+#include <tchar.h>
 
 #include <VBox/com/com.h>
Index: /trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdog.cpp	(revision 60758)
+++ /trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdog.cpp	(revision 60759)
@@ -146,5 +146,5 @@
 #ifdef RT_OS_WINDOWS
 /* Required for ATL. */
-static CComModule _Module;
+static ATL::CComModule _Module;
 #endif
 
Index: /trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp	(revision 60758)
+++ /trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp	(revision 60759)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2015 Oracle Corporation
+ * Copyright (C) 2006-2016 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -590,5 +590,5 @@
 #ifdef RT_OS_WINDOWS
 // Required for ATL
-static CComModule _Module;
+static ATL::CComModule _Module;
 #endif
 
Index: /trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 60758)
+++ /trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 60759)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2015 Oracle Corporation
+ * Copyright (C) 2006-2016 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -93,5 +93,5 @@
 # ifdef RT_OS_WINDOWS
 // Required for ATL
-static CComModule       _Module;
+static ATL::CComModule  _Module;
 # endif
 
Index: /trunk/src/VBox/Frontends/VBoxSDL/Framebuffer.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxSDL/Framebuffer.cpp	(revision 60758)
+++ /trunk/src/VBox/Frontends/VBoxSDL/Framebuffer.cpp	(revision 60759)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2016 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -152,6 +152,5 @@
     mfInitialized = true;
 #ifdef RT_OS_WINDOWS
-    HRESULT hr = CoCreateFreeThreadedMarshaler(this, //GetControllingUnknown(),
-                                             &m_pUnkMarshaler.p);
+    HRESULT hr = CoCreateFreeThreadedMarshaler(this, m_pUnkMarshaler.asOutParam());
     Log(("CoCreateFreeThreadedMarshaler hr %08X\n", hr));
 #endif
@@ -1429,19 +1428,4 @@
 
 /**
- * Returns the address of the framebuffer bits for writing to.
- *
- * @returns COM status code
- * @param   alpha Address of result buffer.
- */
-STDMETHODIMP VBoxSDLFBOverlay::COMGETTER(Address)(ULONG *address)
-{
-    LogFlow(("VBoxSDLFBOverlay::GetAddress\n"));
-    if (!address)
-        return E_INVALIDARG;
-    *address = (uintptr_t) mOverlayBits->pixels;
-    return S_OK;
-}
-
-/**
  * Returns the current colour depth.  In fact, this is always 32bpp.
  *
Index: /trunk/src/VBox/Frontends/VBoxSDL/Framebuffer.h
===================================================================
--- /trunk/src/VBox/Frontends/VBoxSDL/Framebuffer.h	(revision 60758)
+++ /trunk/src/VBox/Frontends/VBoxSDL/Framebuffer.h	(revision 60759)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2006-2015 Oracle Corporation
+ * Copyright (C) 2006-2016 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -44,5 +44,5 @@
 
 class ATL_NO_VTABLE VBoxSDLFB :
-    public CComObjectRootEx<CComMultiThreadModel>,
+    public ATL::CComObjectRootEx<ATL::CComMultiThreadModel>,
     VBOX_SCRIPTABLE_IMPL(IFramebuffer)
 {
@@ -67,5 +67,5 @@
         COM_INTERFACE_ENTRY(IFramebuffer)
         COM_INTERFACE_ENTRY2(IDispatch,IFramebuffer)
-        COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
+        COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.m_p)
     END_COM_MAP()
 
@@ -208,5 +208,5 @@
 
 #ifdef RT_OS_WINDOWS
-     CComPtr <IUnknown>   m_pUnkMarshaler;
+     ComPtr<IUnknown> m_pUnkMarshaler;
 #endif
 };
@@ -245,5 +245,4 @@
     STDMETHOD(COMGETTER(Alpha))(ULONG *alpha);
     STDMETHOD(COMSETTER(Alpha))(ULONG alpha);
-    STDMETHOD(COMGETTER(Address))(ULONG *address);
     STDMETHOD(COMGETTER(BytesPerLine))(ULONG *bytesPerLine);
 
Index: /trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 60758)
+++ /trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 60759)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2015 Oracle Corporation
+ * Copyright (C) 2006-2016 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -739,5 +739,5 @@
 #ifdef RT_OS_WINDOWS
 // Required for ATL
-static CComModule _Module;
+static ATL::CComModule _Module;
 #endif
 