Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp	(revision 60828)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp	(revision 60829)
@@ -20,16 +20,4 @@
 #else  /* !VBOX_WITH_PRECOMPILED_HEADERS */
 
-/* GUI includes: */
-# include "QIFileDialog.h"
-# include "QIToolButton.h"
-# include "QILabel.h"
-# include "QILineEdit.h"
-# include "UIIconPool.h"
-# include "UIFilePathSelector.h"
-# include "VBoxGlobal.h"
-
-/* Other VBox includes: */
-# include <iprt/assert.h>
-
 /* Qt includes: */
 # include <QAction>
@@ -42,4 +30,16 @@
 # include <QTimer>
 
+/* GUI includes: */
+# include "QIFileDialog.h"
+# include "QILabel.h"
+# include "QILineEdit.h"
+# include "QIToolButton.h"
+# include "UIIconPool.h"
+# include "UIFilePathSelector.h"
+# include "VBoxGlobal.h"
+
+/* Other VBox includes: */
+# include <iprt/assert.h>
+
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
 
@@ -68,11 +68,11 @@
 UIFilePathSelector::UIFilePathSelector(QWidget *pParent /* = 0 */)
     : QIWithRetranslateUI<QComboBox>(pParent)
-    , m_pCopyAction(new QAction(this))
     , m_enmMode(Mode_Folder)
     , m_strHomeDir(QDir::current().absolutePath())
     , m_fEditable(true)
+    , m_fModified(false)
     , m_fEditableMode(false)
     , m_fMouseAwaited(false)
-    , m_fModified(false)
+    , m_pCopyAction(new QAction(this))
 {
     /* Populate items: */
@@ -106,18 +106,4 @@
 }
 
-UIFilePathSelector::~UIFilePathSelector()
-{
-}
-
-void UIFilePathSelector::setMode(Mode enmMode)
-{
-    m_enmMode = enmMode;
-}
-
-UIFilePathSelector::Mode UIFilePathSelector::mode() const
-{
-    return m_enmMode;
-}
-
 void UIFilePathSelector::setEditable(bool fEditable)
 {
@@ -169,44 +155,4 @@
 }
 
-void UIFilePathSelector::resetModified()
-{
-    m_fModified = false;
-}
-
-bool UIFilePathSelector::isModified() const
-{
-    return m_fModified;
-}
-
-void UIFilePathSelector::setFileDialogTitle(const QString& strTitle)
-{
-    m_strFileDialogTitle = strTitle;
-}
-
-QString UIFilePathSelector::fileDialogTitle() const
-{
-    return m_strFileDialogTitle;
-}
-
-void UIFilePathSelector::setFileDialogFilters(const QString& strFilters)
-{
-    m_strFileDialogFilters = strFilters;
-}
-
-QString UIFilePathSelector::fileDialogFilters() const
-{
-    return m_strFileDialogFilters;
-}
-
-void UIFilePathSelector::setFileDialogDefaultSaveExtension(const QString &strDefaultSaveExtension)
-{
-    m_strFileDialogDefaultSaveExtension = strDefaultSaveExtension;
-}
-
-QString UIFilePathSelector::fileDialogDefaultSaveExtension() const
-{
-    return m_strFileDialogDefaultSaveExtension;
-}
-
 bool UIFilePathSelector::isPathSelected() const
 {
@@ -230,4 +176,12 @@
 {
     m_strHomeDir = strHomeDir;
+}
+
+bool UIFilePathSelector::eventFilter(QObject *pObject, QEvent *pEvent)
+{
+    if (m_fMouseAwaited && (pEvent->type() == QEvent::MouseButtonPress))
+        QTimer::singleShot(0, this, SLOT(refreshText()));
+
+    return QIWithRetranslateUI<QComboBox>::eventFilter(pObject, pEvent);
 }
 
@@ -260,12 +214,4 @@
     }
     QIWithRetranslateUI<QComboBox>::focusOutEvent(pEvent);
-}
-
-bool UIFilePathSelector::eventFilter(QObject *pObject, QEvent *pEvent)
-{
-    if (m_fMouseAwaited && (pEvent->type() == QEvent::MouseButtonPress))
-        QTimer::singleShot(0, this, SLOT(refreshText()));
-
-    return QIWithRetranslateUI<QComboBox>::eventFilter(pObject, pEvent);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.h	(revision 60828)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.h	(revision 60829)
@@ -19,15 +19,15 @@
 #define ___UIFilePathSelector_h___
 
+/* Qt includes: */
+#include <QComboBox>
+
 /* GUI includes: */
 #include "QIWithRetranslateUI.h"
 
-/* Qt includes: */
-#include <QComboBox>
-
 /* Forward declarations: */
+class QAction;
+class QHBoxLayout;
 class QILabel;
 class QILineEdit;
-class QHBoxLayout;
-class QAction;
 class QIToolButton;
 
@@ -38,4 +38,9 @@
 {
     Q_OBJECT;
+
+signals:
+
+    /** Notify listeners about @a strPath changed. */
+    void pathChanged(const QString &strPath);
 
 public:
@@ -51,11 +56,9 @@
     /** Constructs file-path selector passing @a pParent to QComboBox base-class. */
     UIFilePathSelector(QWidget *pParent = 0);
-    /** Destructs file-path selector. */
-    ~UIFilePathSelector();
 
     /** Defines the @a enmMode to operate in. */
-    void setMode(Mode enmMode);
+    void setMode(Mode enmMode) { m_enmMode = enmMode; }
     /** Returns the mode to operate in. */
-    Mode mode() const;
+    Mode mode() const { return m_enmMode; }
 
     /** Defines whether the path is @a fEditable. */
@@ -70,22 +73,22 @@
 
     /** Defines the file-dialog @a strTitle. */
-    void setFileDialogTitle(const QString &strTitle);
+    void setFileDialogTitle(const QString &strTitle) { m_strFileDialogTitle = strTitle; }
     /** Returns the file-dialog title. */
-    QString fileDialogTitle() const;
+    QString fileDialogTitle() const { return m_strFileDialogTitle; }
 
     /** Defines the file-dialog @a strFilters. */
-    void setFileDialogFilters(const QString &strFilters);
+    void setFileDialogFilters(const QString &strFilters) { m_strFileDialogFilters = strFilters; }
     /** Returns the file-dialog filters. */
-    QString fileDialogFilters() const;
+    QString fileDialogFilters() const { return m_strFileDialogFilters; }
 
     /** Defines the file-dialog @a strDefaultSaveExtension. */
-    void setFileDialogDefaultSaveExtension(const QString &strDefaultSaveExtension);
+    void setFileDialogDefaultSaveExtension(const QString &strDefaultSaveExtension) { m_strFileDialogDefaultSaveExtension = strDefaultSaveExtension; }
     /** Returns the file-dialog default save extension. */
-    QString fileDialogDefaultSaveExtension() const;
+    QString fileDialogDefaultSaveExtension() const { return m_strFileDialogDefaultSaveExtension; }
 
     /** Resets path modified state to false. */
-    void resetModified();
+    void resetModified() { m_fModified = false; }
     /** Returns whether the path is modified. */
-    bool isModified() const;
+    bool isModified() const { return m_fModified; }
     /** Returns whether the path is selected. */
     bool isPathSelected() const;
@@ -93,9 +96,4 @@
     /** Returns the path. */
     QString path() const;
-
-signals:
-
-    /** Notify listeners about @a strPath changed. */
-    void pathChanged(const QString &strPath);
 
 public slots:
@@ -109,4 +107,7 @@
 protected:
 
+    /** Preprocesses every @a pEvent sent to @a pObject. */
+    bool eventFilter(QObject *pObject, QEvent *pEvent);
+
     /** Handles resize @a pEvent. */
     void resizeEvent(QResizeEvent *pEvent);
@@ -116,7 +117,4 @@
     /** Handles focus-out @a pEvent. */
     void focusOutEvent(QFocusEvent *pEvent);
-
-    /** Preprocesses every @a pEvent sent to @a pObject. */
-    bool eventFilter(QObject *pObject, QEvent *pEvent);
 
     /** Handles translation event. */
@@ -154,7 +152,4 @@
     QString shrinkText(int iWidth) const;
 
-    /** Holds the copy action instance. */
-    QAction *m_pCopyAction;
-
     /** Holds the mode to operate in. */
     Mode     m_enmMode;
@@ -165,10 +160,10 @@
     QString  m_strHomeDir;
 
+    /** Holds the file-dialog title. */
+    QString  m_strFileDialogTitle;
     /** Holds the file-dialog filters. */
     QString  m_strFileDialogFilters;
     /** Holds the file-dialog default save extension. */
     QString  m_strFileDialogDefaultSaveExtension;
-    /** Holds the file-dialog title. */
-    QString  m_strFileDialogTitle;
 
     /** Holds the cached text for empty path. */
@@ -179,4 +174,6 @@
     /** Holds whether the path is editable. */
     bool     m_fEditable;
+    /** Holds whether the path is modified. */
+    bool     m_fModified;
 
     /** Holds whether we are in editable mode. */
@@ -185,6 +182,6 @@
     bool     m_fMouseAwaited;
 
-    /** Holds whether the path is modified. */
-    bool     m_fModified;
+    /** Holds the copy action instance. */
+    QAction *m_pCopyAction;
 };
 